package com.jeeplus.test.cw.workClientInfo.service;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.common.collect.Lists;
import com.jeeplus.core.query.QueryWrapperGenerator;
import com.jeeplus.test.cw.workClientInfo.domain.CwWorkClientBase;
import com.jeeplus.test.cw.workClientInfo.mapper.*;
import com.jeeplus.test.cw.workClientInfo.service.dto.CwWorkClientBaseDTO;
import com.jeeplus.test.cw.workClientInfo.service.mapstruct.CwWorkClientBaseWrapper;
import com.jeeplus.test.oss.service.OssService;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

@Service
@Transactional
public class CwWorkClientService extends ServiceImpl<CwWorkClientBaseMapper, CwWorkClientBase> {

    @Resource
    private CwWorkClientBaseMapper cwWorkClientBaseMapper;
    @Resource
    private CwWorkClientBillingMapper cwWorkClientBillingMapper;
    @Resource
    private CwWorkClientContactMapper cwWorkClientContactMapper;
    @Resource
    private CwWorkClientTypeMapper cwWorkClientTypeMapper;
    @Resource
    private CwManageLevelTypeService cwManageLevelTypeService;
    @Resource
    private CwOrganizationTypeService cwOrganizationTypeService;
    @Resource
    private OssService ossService;

    public IPage<CwWorkClientBaseDTO> findList(Page<CwWorkClientBaseDTO> page, CwWorkClientBaseDTO cwWorkClientBaseDTO) throws Exception{
        QueryWrapper<CwWorkClientBase> queryWrapper = QueryWrapperGenerator.buildQueryCondition ( CwWorkClientBaseWrapper.INSTANCE.toEntity(cwWorkClientBaseDTO), CwWorkClientBase.class );
        queryWrapper.eq("cw_wcb.del_flag","0");
        queryWrapper.orderByDesc("cw_wcb.create_date");
        IPage<CwWorkClientBaseDTO> list = cwWorkClientBaseMapper.findList(page, queryWrapper);
        return list;
    }

    public CwWorkClientBaseDTO queryById(String id) {

        CwWorkClientBaseDTO cwWorkClientBaseDTO = cwWorkClientBaseMapper.queryById(id);

        return cwWorkClientBaseDTO;
    }

    public String saveForm(CwWorkClientBaseDTO cwWorkClientBaseDTO) throws Exception{
        CwWorkClientBase cwWorkClientBase = CwWorkClientBaseWrapper.INSTANCE.toEntity(cwWorkClientBaseDTO);
        this.saveOrUpdate(cwWorkClientBase);
        if (ObjectUtil.isNotEmpty(cwWorkClientBaseDTO)) {
            //附件
            ossService.saveOrUpdateFileList(cwWorkClientBaseDTO.getWorkAttachmentDtoList(),cwWorkClientBase.getId(),"cw_work_client");
        }
        return cwWorkClientBase.getId();
    }

    public ResponseEntity saveClient(CwWorkClientBaseDTO cwWorkClientBaseDTO) throws Exception{
        this.saveForm(cwWorkClientBaseDTO);
        return ResponseEntity.ok("保存成功");
    }

    public ResponseEntity deleteByIds(String ids) {
        String idArray[] =ids.split(",");
        this.removeByIds (Lists.newArrayList (idArray));
        return ResponseEntity.ok ("删除成功");
    }

    public String updateStatusById(CwWorkClientBaseDTO cwWorkClientBaseDTO) {
        CwWorkClientBase cwWorkClientBase = CwWorkClientBaseWrapper.INSTANCE.toEntity(cwWorkClientBaseDTO);
        cwWorkClientBaseMapper.update(cwWorkClientBase, new QueryWrapper<CwWorkClientBase>().lambda().eq(CwWorkClientBase::getId, cwWorkClientBase.getId()));
        return "操作成功";
    }

}
